



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>php中序列化与反序列化</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">php中序列化与反序列化</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 15:29:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>解析PHP多种序列化与反序列化的方法</h1>
<p>序列化是将变量转换为可保存或传输的字符串的过程；反序列化就是在适当的时候把这个字符串再转化成原来的变量使用。这两个过程结合起来，可以轻松地存储和传输数据，使程序更具维护性。<br><strong>1. serialize和unserialize函数<br></strong>这两个是序列化和反序列化PHP中数据的常用函数。</p>
<div>复制代码代码如下:</div>
<div><br>&lt;?php<br>$a = array('a'=&gt; 'Apple' ,'b' =&gt; 'banana', 'c' =&gt; 'Coconut');<br>//序列化数组<br>$s = serialize($a);<br>echo $s;<br>//输出结果：a:3:{s:1:"a";s:5:"Apple";s:1:"b";s:6:"banana";s:1:"c";s:7:"Coconut";}<br>echo '&lt;br /&gt;&lt;br /&gt;';<br>//反序列化<br>$o = unserialize($s);<br>print_r($o);<br>//输出结果 Array ( [a] =&gt; Apple [b] =&gt; banana [c] =&gt; Coconut )<br>?&gt;</div>
<p>当数组值包含如双引号、单引号或冒号等字符时，它们被反序列化后，可能会出现问题。为了克服这个问题，一个巧妙的技巧是使用base64_encode和base64_decode。</p>
<div>复制代码代码如下:</div>
<div><br>$obj = array();<br>//序列化<br>$s = base64_encode(serialize($obj));<br>//反序列化<br>$original = unserialize(base64_decode($s));<br>但是base64编码将增加字符串的长度。为了克服这个问题，可以和gzcompress一起使用。<br>//定义一个用来序列化对象的函数<br>function my_serialize($obj )<br>{<br>&nbsp;&nbsp; returnbase64_encode(gzcompress(serialize($obj)));<br>}<br>//反序列化<br>function my_unserialize($txt)<br>{<br>&nbsp;&nbsp; returnunserialize(gzuncompress(base64_decode($txt)));<br>}</div>
<p><strong>2. json_encode 和 json_decode<br></strong>使用JSON格式序列化和反序列化是一个不错的选择：&nbsp;<br>&nbsp;&nbsp;&nbsp; 使用json_encode和json_decode格式输出要serialize和unserialize格式快得多。<br>&nbsp;&nbsp;&nbsp; JSON格式是可读的。<br>&nbsp;&nbsp;&nbsp; JSON格式比serialize返回数据结果小。<br>&nbsp;&nbsp;&nbsp; JSON格式是开放的、可移植的。其他语言也可以使用它。</p>
<div>复制代码代码如下:</div>
<div><br>$a = array('a'=&gt; 'Apple' ,'b' =&gt; 'banana', 'c' =&gt; 'Coconut');<br /><br />//序列化数组<br>$s = json_encode($a);<br>echo $s;<br>//输出结果：{"a":"Apple","b":"banana","c":"Coconut"}<br>echo '&lt;br /&gt;&lt;br /&gt;';<br>//反序列化<br>$o = json_decode($s);</div>
<p>在上面的例子中，json_encode输出长度比上个例子中serialize输出长度显然要短。<br><strong>3. var_export 和 eval<br></strong>var_export 函数把变量作为一个字符串输出；eval把字符串当成PHP代码来执行，反序列化得到最初变量的内容。</p>
<div>复制代码代码如下:</div>
<div><br>$a = array('a'=&gt; 'Apple' ,'b' =&gt; 'banana', 'c' =&gt; 'Coconut');<br /><br />//序列化数组<br>$s = var_export($a, true);<br>echo $s;<br>//输出结果： array ( 'a' =&gt; 'Apple', 'b' =&gt; 'banana', 'c' =&gt; 'Coconut', )<br>echo '&lt;br /&gt;&lt;br /&gt;';<br>//反序列化<br>eval('$my_var='. $s . ';');<br>print_r($my_var);</div>
<p><strong>4. wddx_serialize_value 和 wddx deserialize<br></strong>wddx_serialize_value函数可以序列化数组变量，并以XML字符串形式输出。</p>
<div>复制代码代码如下:</div>
<div><br>$a = array('a'=&gt; 'Apple' ,'b' =&gt; 'banana', 'c' =&gt; 'Coconut');<br /><br />//序列化数组<br>$s = wddx_serialize_value($a);<br>echo $s;<br>//输出结果（查看输出字符串的源码）：&lt;wddxPacket version='1.0'&gt;&lt;header/&gt;&lt;data&gt;&lt;struct&gt;&lt;var name='a'&gt;&lt;string&gt;Apple&lt;/string&gt;&lt;/var&gt;&lt;var name='b'&gt;&lt;string&gt;banana&lt;/string&gt;&lt;/var&gt;&lt;var name='c'&gt;&lt;string&gt;Coconut&lt;/string&gt;&lt;/var&gt;&lt;/struct&gt;&lt;/data&gt;&lt;/wddxPacket&gt;<br>echo '&lt;br /&gt;&lt;br /&gt;';<br>//反序列化<br>$o = wddx_deserialize($s);<br>print_r($o);<br>//输出结果：Array ( [a] =&gt; Apple [b] =&gt; banana 1 =&gt; Coconut )</div>
<p>可以看出，XML标签字符较多，导致这种格式的序列化还是占了很多空间。<br><strong>小结<br></strong>上述所有的函数在序列化数组变量时都能正常执行，但运用到对象就不同了。例如json_encode序列化对象就会失败。反序列化对象时，unserialize和eval将有不同的效果。</p>
<p>转自：<a href="http://qing.weibo.com/tag/unserialize" rel="external nofollow noreferrer">http://qing.weibo.com/tag/unserialize</a></p>
<p>把复杂的数据类型压缩到一个字符串中</p>
<div>serialize() 把变量和它们的值编码成文本形式</div>
<div>unserialize() 恢复原先变量</p>
<div>eg:</div>
<div>
<div>
<div>
<pre class="prettyprint linenums">$stooges = array('Moe','Larry','Curly');<br>$new = serialize($stooges);<br>print_r($new);echo "&lt;br /&gt;";<br>print_r(unserialize($new));</pre>
</div>
</div>
<div>结果：a:3:{i:0;s:3:"Moe";i:1;s:5:"Larry";i:2;s:5:"Curly";}</div>
<p>Array ( [0] =&gt; Moe [1] =&gt; Larry [2] =&gt; Curly )</p></div>
</div>
<div>当把这些序列化的数据放在URL中在页面之间会传递时，需要对这些数据调用urlencode()，以确保在其中的URL元字符进行处理：</div>
<div>
<div>
<pre class="prettyprint linenums">$shopping = array('Poppy seed bagel' =&gt; 2,'Plain Bagel' =&gt;1,'Lox' =&gt;4);<br>echo '&lt;a href="next.php?cart='.urlencode(serialize($shopping)).'"&gt;next&lt;/a&gt;';</pre>
</div>
</div>
<div>margic_quotes_gpc和magic_quotes_runtime配置项的设置会影响传递到unserialize()中的数据。</div>
<div>如果magic_quotes_gpc项是启用的，那么在URL、POST变量以及cookies中传递的数据在反序列化之前必须用stripslashes()进行处理：</div>
<div>
<div>
<pre class="prettyprint linenums">$new_cart = unserialize(stripslashes($cart)); //如果magic_quotes_gpc开启<br>$new_cart = unserialize($cart);</pre>
</div>
</div>
<div>如果magic_quotes_runtime是启用的，那么在向文件中写入序列化的数据之前必须用addslashes()进行处理，而在读取它们之前则必须用stripslashes()进行处理：</div>
<div>
<div>
<div><img referrerpolicy="no-referrer"src="http://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">$fp = fopen('/tmp/cart','w');<br>fputs($fp,addslashes(serialize($a)));<br>fclose($fp);<br>//如果magic_quotes_runtime开启<br>$new_cat = unserialize(stripslashes(file_get_contents('/tmp/cart')));<br>//如果magic_quotes_runtime关闭<br>$new_cat = unserialize(file_get_contents('/tmp/cart'));<br>在启用了magic_quotes_runtime的情况下，从数据库中读取序列化的数据也必须经过stripslashes()的处理，保存到数据库中的序列化数据必须要经过addslashes()的处理，以便能够适当地存储。<br>mysql_query("insert into cart(id,data) values(1,'".addslashes(serialize($cart))."')");<br>$rs = mysql_query('select data from cart where id=1');<br>$ob = mysql_fetch_object($rs);<br>//如果magic_quotes_runtime开启<br>$new_cart = unserialize(stripslashes($ob-&gt;data));<br>//如果magic_quotes_runtime关闭<br>$new_cart = unserialize($ob-&gt;data);</pre>
<div><img referrerpolicy="no-referrer"src="http://common.cnblogs.com/images/copycode.gif"></div>
</div>
</div>
<div>当对一个对象进行反序列化操作时，PHP会自动地调用其__wakeUp()方法。这样就使得对象能够重新建立起序列化时未能保留的各种状态。例如：数据库连接等。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pxj4yq.html">vs visual studio 让外网访问设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gdwge9.html">myeclipse激活法，可以试一试</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7do3xq.html">xampp3&period;2下mysql中文乱码终极解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4wkmn9.html">【HDU 5750】Dertouzos（数学）</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwgjd38.html">java中string stringbuilder stringbuffer 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlzdx08.html">Swift-08-闭包引起的循环强引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnw1je8.html">BZOJ 1976 能量魔方 Cube（最小割）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm3r4e9.html">欧拉工程第51题：Prime digit replacements</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7l269.html">10&period; 将摄像机对准物体，并显示整个对准过程，摄像机Zoom</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xenp68.html">Hibernate级联删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdenxkx9.html">C 语言中实现数据与方法的封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgzowd8.html">C&num; - 接口的继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj2v6g8.html">js MD5加密后的字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj4rgx8.html">openstack集群环境准备</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mevl30q.html">hihoCoder 1493 &colon; 歌德巴赫猜想 素数筛法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll0y1q.html">secureCRT常见命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyx5nx9.html">hdu 2577 How to Type&lpar;dp&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll0rg0q.html">打开Delphi 10&period;1 berlin提示脚本错误的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/960x1v39.html">PAT 1042 字符统计&lpar;20&rpar;（思路）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k33n3q.html">Windows 安装并配置 MySQL 5&period;6</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqvrz118.html">iOS－－基础控件总结一</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p3k7dq.html">Unity 摄像机组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q22mg3q.html">在Unity中创建可远程加载的&period;unity3d包</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ej5lm9.html">支持coclock模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/390pelo8.html">OpenGL管线（用经典管线代说着色器内部）</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93vv3r8.html">web开发实战--图片裁剪和上传</a>
			</li>
						<li><a href="https://www.batexi.com/a/390p4l38.html">js 字符串转换成数字的三种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93v6vg8.html">jsp之tomcat安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z4lzd9.html">iOS应用之间调用</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdz35v9.html">MySQL学习总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
